/* Ko` version 1.00 */
/*           1999 Rick */

#include	"honkon.h"
#include	<winop.h>
#include	<sys_doslib.h>
#include	<cardlib.h>
#include	<string.h>

int	WindowHeapSize = CardHeapSize( JpaiMaximum );

extern Sheet	cong2Pattern;

static unsigned int	starttime, endtime, worktime;
static int	rest;
static Cards	*pai;
static HISTORY	*sp, stack[68];
static char	savename[128];


static void
rankinit()
{
	int	i;

	for( i= 0; i < 5; i++ ){
		ranking[i].time= 23 * 3600 + 59 * 60 + 59;
		strcpy( ranking[i].times, "23:59:59" );
		strcpy( ranking[i].name, "None" );
	}
}

void
timeget( end )
int	end;
{
	unsigned int	tmp;
	char	*ptr;

	strcpy( timestr, "     :00" );
	end/= 100;
	tmp= end / 3600;
	if( tmp ){
		ptr= timestr;
		if( tmp < 10 )	ptr++;
		itoa( tmp, ptr, 10 );
		timestr[2]= ':';
		timestr[3]= '0';
	}
	end%= 3600;
	tmp= end / 60;
	ptr= timestr + 4;
	if( tmp >= 10 )	ptr--;
	itoa( tmp, ptr, 10 );
	timestr[5]= ':';
	end%= 60;
	ptr= timestr + 6;
	if( end < 10 )	ptr++;
	itoa( end, ptr, 10 );
}

static void
menuput( wp )
WindowID	wp;
{
	DrawBuf	dbuf[3], *dp= dbuf;
	char	itoabuf[6];

	itoa( rest, itoabuf, 10 );
	DrawSetSymbol( dp++, 0, 0, "GIVEUP BACK  HINT  RANK ", AttrDefault, FONT_V );
	DrawSetSymbol( dp++, 300, 0, "rest    ", AttrDefault, FONT_V );
	DrawSetSymbol( dp++, 330, 0, itoabuf, AttrDefault, FONT_V );

	WindowDraw( wp, dbuf, dp - dbuf );
}

static void
back( wp )
WindowID	wp;
{
	DrawBuf	dbuf[2];
	int	x, y;

	if( !rest || rest == 136 )	return;

	sp--;
	x= sp->j1 % 17;
	y= sp->j1 / 17;
	(unsigned char)map[y][x]-= 0x80;
	CardDrawSetMono( dbuf, x * JpaiSizeX, y * JpaiSizeY + MENU_V,
					 map[y][x], pai );
	x= sp->j2 % 17;
	y= sp->j2 / 17;
	(unsigned char)map[y][x]-= 0x80;
	CardDrawSetMono( dbuf + 1, x * JpaiSizeX, y * JpaiSizeY + MENU_V,
					 map[y][x], pai );
	WindowDraw( wp, dbuf, 2 );

	rest+= 2;
}

static void
cancel( wp )
WindowID	wp;
{
	DrawBuf	dbuf[1];

	if( pos.x1 >= 0 ){
		CardDrawSetMono( dbuf, pos.x1 * JpaiSizeX,
						pos.y1 * JpaiSizeY + MENU_V,
						map[pos.y1][pos.x1], pai );
		WindowDraw( wp, dbuf, 1 );
	}
	pos.x1= -1;
}

static void
click( wp, x, y )
WindowID	wp;
int	x;
int	y;
{
	DrawBuf	dbuf[2], *dp= dbuf;

	x/= JpaiSizeX;
	y/= JpaiSizeY;

	if( pos.x1 < 0 ){			/* ڂ̑I */
		if( map[y][x] >= 0 ){	/* v */
			DrawSetLine( dp, x * JpaiSizeX, y * JpaiSizeY + MENU_V,
						x * JpaiSizeX + JpaiSizeX - 1,
						y * JpaiSizeY + JpaiSizeY - 1 + MENU_V,
						ColorWhite + OptionXor, OptionFill );
			WindowDraw( wp, dbuf, 1 );
			pos.x1= x;
			pos.y1= y;
		}
		return;
	}

	if( pos.x1 == x && pos.y1 == y ){	/* ꖇڂĂёI */
		cancel( wp );
		return;
	}

	if( map[pos.y1][pos.x1] == map[y][x] ){	/* ꖇڂƓv */
		pos.x2= x;
		pos.y2= y;
		if( check( &pos ) ){				/*  */
			DrawSetLine( dp++, x * JpaiSizeX, y * JpaiSizeY + MENU_V,
						x * JpaiSizeX + JpaiSizeX - 1,
						y * JpaiSizeY + JpaiSizeY - 1 + MENU_V,
						ColorGray, OptionFill );
			DrawSetLine( dp, pos.x1 * JpaiSizeX, pos.y1 * JpaiSizeY + MENU_V,
						pos.x1 * JpaiSizeX + JpaiSizeX - 1,
						pos.y1 * JpaiSizeY + JpaiSizeY - 1 + MENU_V,
						ColorGray, OptionFill );
			WindowDraw( wp, dbuf, 2 );
			(unsigned char)map[y][x]+= 0x80;
			(unsigned char)map[pos.y1][pos.x1]+= 0x80;
			sp->j1= y * 17 + x;
			sp->j2= pos.y1 * 17 + pos.x1;
			sp++;
			pos.x1= -1;
			rest-= 2;
			menuput( wp );
			if( !rest ){		/* SĂ̔v */
				endtime= IntervalTime() - starttime;
				WindowSetEventAttr( wp, EventAttrDefault|EventIconifyON );
				timeget( endtime );
				if( rank_open( wp, endtime ) ){
					WindowRedraw( wp );
				}
			}
		}
	}
}

static void
shuffle( wp )
WindowID	wp;
{
	int	i, j, x, y;
	char	p[34];

	srand( GETTIM2() );

	for( i= 0; i < 34; i++ ){
		p[i]= 4;
	}

	x= 0;
	y= 0;

	for( i= 136; i > 0; i-- ){
		while( 1 ){
			j= ( rand() >> 8 ) % 34;
			if( p[j] ){
				p[j]--;
				break;
			}
		}
		imap[j][p[j]].j1= x;
		imap[j][p[j]].j2= y;
		map[y][x]= j;
		if( ++x == 17 )	x= 0;
		if( ++y == 8 )	y= 0;
	}
	pos.x1= -1;
	rest= 136;
	WindowSetEventAttr( wp, EventAttrDefault|EventIconifyON|EventIntervalON );
	starttime= IntervalTime();
	sp= stack;
}

static void
redraw( wp )
WindowID	wp;
{
	DrawBuf	dbuf[18], *dp= dbuf;
	int	i, j;

	DrawSetClear( dp++, 1 );
	for( i= 0; i < 8; i++ ){
		for( j= 0; j < 17; j++ ){
			if( map[i][j] >= 0 ){
				CardDrawSetMono( dp++, j * JpaiSizeX,
								 i * JpaiSizeY + MENU_V,
								 map[i][j], pai );
			}
		}
		WindowDraw( wp, dbuf, dp - dbuf );
		dp= dbuf;
	}
}


static void
menuselect( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[1];
	int	n= info->x / ( FONT_H * 6 );

	if( n > 3 )	return;
	DrawSetLine( dbuf, n * FONT_H * 6, 0, n * FONT_H * 6 + FONT_H * 6 - 1, FONT_V - 1,
					ColorGray + OptionXor, OptionFill );
	WindowDraw( wp, dbuf, 1 );

	switch( n ){
	case 0:	/* GIVEUP */
		shuffle( wp );
		WindowRedraw( wp );
		break;
	case 1:	/* BACK */
		back( wp );
		break;
	case 2:	/* HINT */
		if( rest )	search( wp );
		break;
	case 3:	/* RANK */
		rank_open( wp, 0 );
		break;
	}
	menuput( wp );
}

static int
Exec( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[4], *dp= dbuf;

	switch( info->option ){
	case EventInterval:
		if( IntervalWait( 100, &worktime ) ){
			endtime= IntervalTime() - starttime;
			timeget( endtime );
			DrawSetSymbol( dbuf, JpaiSizeX * 17 - FONT_H * 8, 0,
							timestr, AttrDefault, FONT_V );
			WindowDraw( wp, dbuf, 1 );
			return TRUE;
		}
		return FALSE;
	case EventOpen:
		WindowSetEventAttr( wp, EventAttrDefault|EventIconifyON );
		shuffle( wp );
		WindowRedraw( wp );
		return TRUE;
	case EventClose:
		if( *savename ){
			short	fn;
			fn= CREATE( savename, 0x20 );
			if( fn >= 0 ){
				WRITE( fn, ranking, sizeof( SCORE ) * 5 );
				CLOSE( fn );
			}
		}
		JpaiClose();
		WindowClose( wp );
		WindowConnectionClose();
		return TRUE;
	case EventRedraw:
		if( rest ){
			redraw( wp );
		}else {
			DrawSetClear( dp++, 1 );
			DrawSetPut( dp++, 76, 63, &cong2Pattern );
			DrawSetSymbol( dp++, 138, 204, "clear time ...", AttrDefault, FONT_V );
			DrawSetSymbol( dp++, 138 + 90, 204, timestr, AttrDefault, FONT_V );
			WindowDraw( wp, dbuf, dp - dbuf );
		}
		menuput( wp );
		return TRUE;
	case EventIconify:
		IconEnt( wp, "`", AttrDefault, FONT_V );
		return TRUE;
	case EventMouseSwitch:
		if( info->LeftON ){
			if( info->y < MENU_V ){
				menuselect( wp, info );
			}else if( !rest ){
				shuffle( wp );
				WindowRedraw( wp );
			}else {
				click( wp, info->x, info->y - MENU_V );
			}
		}else if( info->RightON ){
			cancel( wp );
		}
		return TRUE;
	}
	return FALSE;
}



int
WindowMain( argc, argv )
int	argc;
char	**argv;
{
	int	x= 160, y= 120;
	short	fn;
	char	*ptr;

	pai= JpaiOpen();
	if( !pai ){
		ConsoleOpen();
		ConsolePrint( "` : vf[^I[vo܂\n" );
		WindowConnectionClose();
		return FALSE;
	}

	ptr= KoWindowGetEnv( "home" );
	if( !ptr )	ptr= KoWindowGetEnv( "HOME" );
	if( !ptr ){
		*savename= NULL;
		rankinit();
	}else {
		char	*wptr= savename;
		do {
			if( *ptr == '/' ){
				*wptr++= '\\';
			}else {
				*wptr++= *ptr;
			}
		} while( *ptr++ );
		if( *(wptr - 1) != '\\' )	*(wptr - 1)= '\\';
		strcpy( wptr, "honkon.sco" );
		fn= OPEN( savename, 0 );
		if( fn >= 0 ){
			READ( fn, ranking, sizeof( SCORE ) * 5 );
			CLOSE( fn );
		}else {
			rankinit();
		}
	}

	argc= AnalyzeArgs( argc, argv, &x, &y, NULL, NULL );
	WindowTitleOpen( x, y, JpaiSizeX * 17, JpaiSizeY * 8 + MENU_V,
						 NULL, "Ko` v1.00", Push|Close|Icon, Exec );
	return TRUE;
}
